<?php
ob_start();
require_once('./config.php');
require_once('utilities/utils.php');
require_once('smarty/Smarty_ml.class.php');
SetLanguage(DEFAULT_LANGUAGE);

$export = null;
$writer = null;

$compression = $_REQUEST["compression"];
$mime_type  = '';
$extension = '';
$save_dir = $_REQUEST["save_dir"];
$backup_method = $_REQUEST["backup_method"];
$export_type = $_REQUEST["export_type"];
$selected_database = $_REQUEST["selected_database"];
$mail_subject = $_REQUEST["mail_subject"];
$mail_to = $_REQUEST["mail_to"];
$mail_cc = $_REQUEST["mail_cc"];
$ftp_file_name = $_REQUEST["txt_edit_filename_template"];
if (isset($_REQUEST["shownames"])) {
	$shownames = $_REQUEST["shownames"];
} else {
	$shownames = "";
}
if (isset($_REQUEST["replace_null"])) {
	$replace_null = $_REQUEST["replace_null"];
}
if (isset($_REQUEST["structure"])) {
	$structure = $_REQUEST["structure"];
}
if (isset($_REQUEST["showcolumns"])) {
	$showcolumns = $_REQUEST["showcolumns"];
} else {
	$showcolumns = "";
}
if (isset($_REQUEST["header_comment"])) {
	$header_comment = $_REQUEST["header_comment"];
} else {
	$header_comment = "";
}
$data = $_REQUEST["data"];
$db_select = $_REQUEST["db_select"];

if (!isset($_REQUEST["db_select"])) {
	header("Location: index.php?main_tabid=0&main_content=index_export.php");
	exit;
}

$what = $_REQUEST["what"];

if ($what == 'htmlexcel') {
	$extension = '.xls';
	$mime_type = 'application/vnd.ms-excel';
} else if ($what == 'htmlword') {
	$extension = '.doc';
	$mime_type = 'application/vnd.ms-word';
} else if ($what == 'latex') {
    $extension  .= '.tex';
    $mime_type = 'application/x-tex';
} else if ($what == 'excel' || $what == 'csv') {
	$extension = '.csv';
	$mime_type = 'text/comma-separated-values';
} else if ($what == 'sql'){
	$extension = '.sql';
	$mime_type = 'text/x-sql';
}

if (isset($compression) && $compression == 'gzip') {
	if (!@ini_get('zlib.output_compression')) {
		$mime_type = 'application/x-gzip';
	}
} else if (isset($compression) && $compression == 'zip') {
	$mime_type = 'application/zip';
}

if ($backup_method == 'local_backup'){
	require_once('writers/file_writer.php');

	$writer = & new CFileWriter($compression, $extension, $save_dir);
}

if ($backup_method == 'email_backup'){
	require_once('writers/email_writer.php');
			$databasenamepass = "";
			if($selected_database == '')
			{
				for($i = 0 ; $i < count($db_select) ; $i++)
					$databasenamepass .= $db_select[$i].",";
			} else{
				$databasenamepass = $selected_database;
			}
	 $i=$_REQUEST['emaili'];
	 $writer = & new CEmailWriter($compression, $mime_type, $send_type[$i], $mail_to, $mail_cc, $mail_subject, $mail_format[$i], $smtp_host[$i], $smtp_port[$i], $smtp_auth[$i], $smtp_user[$i], $smtp_passw[$i], $sendmail_path[$i], $extension,$databasenamepass, ADMIN);

}

if ($backup_method == 'ftp_backup'){
	require_once('writers/ftp_writer.php');
	$i=$_REQUEST['i'];
	$errorOccurs = false;
	if (!checkFTP($ftp_host[$i], $ftp_login[$i], $ftp_password[$i], $ftp_save_dir[$i]))
	{
			$errorOccurs = true;
			//$GLOBALS['ftpSettingsInCorrect'];
	}
	$writer = & new CFTPWriter($compression, $extension, $ftp_save_dir[$i], $ftp_host[$i], $ftp_login[$i], $ftp_password[$i],$ftp_file_name);
}

if ($what == 'htmlexcel') {
	require_once('formatters/htmlexcel_formatter.php');
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CHtmlExcelFormatter($shownames, $replace_null, $writer, $connection);
}

if ($what == 'htmlword') {
	require_once('formatters/htmlword_formatter.php');
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CHtmlWordFormatter($shownames, $replace_null, $writer, $connection);
}

if ($what == 'latex'){
	require_once('formatters/latex_formatter.php');

	$latex_caption = $_REQUEST["latex_caption"];
	$latex_data_caption = $_REQUEST["latex_data_caption"];
	$latex_data_label = $_REQUEST["latex_data_label"];
	$latex_data_continued_caption = $_REQUEST["latex_data_continued_caption"];
	$latex_structure_continued_caption = $_REQUEST["latex_structure_continued_caption"];
	$latex_structure_caption = $_REQUEST["latex_structure_caption"];
	$latex_structure_label = $_REQUEST["latex_structure_label"];
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CLaTeXFormatter($latex_caption, $latex_data_caption, $latex_data_label, $showcolumns,
									$latex_data_continued_caption, $replace_null, $latex_structure_continued_caption,
									$latex_structure_caption, $latex_structure_label, $writer, $connection);
}

if ($what == 'sql') {
	require_once('formatters/sql_formatter.php');

	$sql_auto_increment = $_REQUEST["sql_auto_increment"];
	if (isset($_REQUEST["if_not_exists"])) {
		$if_not_exists = $_REQUEST["if_not_exists"];
	} else {
		$if_not_exists = "";
	}
	if (isset($_REQUEST["drop"])) {
		$drop_table = $_REQUEST["drop"];
	} else {
		$drop_table = "";
	}
	$use_backquotes = $_REQUEST["use_backquotes"];
	$sql_type = $_REQUEST["sql_type"];
	if (isset($_REQUEST["extended_ins"])) {
		$extended_ins = $_REQUEST["extended_ins"];
	} else {
		$extended_ins = "";
	}
	$hexforbinary = $_REQUEST["hexforbinary"];
	if (isset($_REQUEST["sql_ignore"])) {
		$sql_ignore = $_REQUEST["sql_ignore"];
	} else {
		$sql_ignore = "";
	}
	if (isset($_REQUEST["delayed"])) {
		$delayed = $_REQUEST["delayed"];
	} else {
		$delayed = "";
	}
	if (isset($_REQUEST["disable_fk"])) {
		$disable_fk = $_REQUEST["disable_fk"];
	} else {
		$disable_fk = "";
	}
	if (isset($_REQUEST["use_transaction"])) {
		$use_transaction = $_REQUEST["use_transaction"];
	} else {
		$use_transaction = "";
	}
	if (isset($_REQUEST["sql_dates"])) {
		$sql_dates  = $_REQUEST["sql_dates"];
	} else {
		$sql_dates = "";
	}
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CSqlFormatter($drop_table, $use_backquotes, $sql_auto_increment, $if_not_exists, $sql_type, $sql_ignore, $delayed, $showcolumns, $extended_ins, $hexforbinary, $disable_fk, $use_transaction, $writer, $connection, $sql_dates, $header_comment);
	$connection->disconnect();
}

if ($what == 'excel'){
	require_once('formatters/excel_formatter.php');
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CExcelFormatter($shownames, $replace_null, $writer, $connection);
}

if ($what == 'csv'){
	require_once('formatters/csv_formatter.php');

	$add_character = $_REQUEST["add_character"];
	$export_separator = $_REQUEST["export_separator"];
	$enclosed = $_REQUEST["enclosed"];
	$escaped = $_REQUEST["escaped"];
	$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
	$connection = DB::connect($connection_string);
	$export = & new CSVFormatter($shownames, $replace_null, $add_character, $export_separator, $enclosed, $escaped, $writer, $connection);
}

$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST;
$connection = DB::connect($connection_string);

$is_mysql_result = false;
$Success = 'false';
$current_db_new = array();
$table_new = array();

if (!isset($db_select)) {
	if ($export_type == 'server') {
		$is_mysql_result = true;
		$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST."/".$selected_database;
		$connection = DB::connect($connection_string);
		$result = $connection->query("SHOW DATABASES");
		$db_select = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ORDERED)) {
			$db_select[] = $row[0];
		}
	} else if ($export_type == 'database') {
		$is_mysql_result = true;

		$connection->disconnect();
		$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST."/".$selected_database;
		$connection = DB::connect($connection_string);
		$result = $connection->getTables();
		if (DB::isError($result)) {
        	die ("Error in query");
		}
		if ($result) {
			foreach ($result as $key=>$table) {
				$db_select[] = $table;
			}
		}
		$connection->freeresult($result);
	}
}


if (!$export->exportHeader()) break;

if ($export_type == 'server') {
	$Success = 'true';
	foreach ( $db_select as $key => $current_db ) {
		if (!$export->exportDBHeader($current_db))
			break 2;
	    if (!$export->exportDBCreate($current_db))
	        break 2;


	    $current_db_new[] = $current_db;

		$connection->disconnect();
		$connection_string = "mysql://".DB_USER.":".DB_PASS."@".DB_HOST."/".$current_db;
		$connection = DB::connect($connection_string);
		$result = $connection->getTables();
		if (DB::isError($result)) {
        	die ("<font size='1'>".date("m.d.Y H:i:s")." :: handler.class.php -> addYear() -> Error in query $sql</font><br>");
		}
		if ($result) {
			foreach ($result as $key=>$table) {
				$table_new[] = $table;
				$local_query  = 'SELECT * FROM `' . $current_db . '`.`' . $table . '`';
				if (isset($structure)) {
		            if (!$export->exportStructure($current_db, $table, $connection)) {
		                break 2;
		            }
				}
		        if (isset($data)) {
					if (!$export->exportData($current_db, $table, $local_query, $connection)) {
						break 2;
					}
		        }
			}
		}
		if (isset($tables)) {
			$connection->freeresult($tables);
		}
	    if (!$export->exportDBFooter($current_db))
	    	break 2;
	}

} else if ($export_type == 'database') {
	$Success = 'true';
	foreach ($db_select as $key => $table) {
	$table_arr = explode(".", $table);
	$table_name = "";
	$selected_database = "";
		if (isset($table_arr[1])) {
			$selected_database = $table_arr[0];
			if (!$export->exportDBHeader($selected_database)) break;
			break;
		}
	}
	foreach ($db_select as $key => $table) {
		$table_arr = explode(".", $table);
		$table_name = "";
		$selected_database = "";
		if (isset($table_arr[1])) {
			$table_name = $table_arr[1];
			$selected_database = $table_arr[0];
			$current_db_new[$selected_database] = $selected_database;
		}
		$table_new[] =  $table_name;
		$local_query  = 'SELECT * FROM `' . $selected_database . '`.`' . $table_name . '`';
	   	if (isset($structure)) {
	   		if (!$export->exportStructure($selected_database, $table_name, $connection))
	   			break 1;
	   	}
	    if (isset($data)) {
	    	if (!$export->exportData($selected_database, $table_name, $local_query, $connection))
	    		break 1;
	    }
	}

    if (!$export->exportDBFooter($selected_database)) break;
}

if (!$export->exportFooter()) break;

$export->finalize();

//$writer->close();
$backupfilename = $_REQUEST['save_dir'].'/'.$writer->filename;
if ($backup_method == 'local_backup')
{
	$download_link_db = "down.php?filename=".$backupfilename;
/*echo '<script>window.open("down.php?filename='.$backupfilename.'");</script>';*/
/*echo '<script>window.location="down.php?filename='.$backupfilename.'";</script>';*/
//@unlink($backupfilename);

//exit();
}

ob_end_clean();	//removes the unneccessary warning messages......

if (isset($_SESSION["smarty"])){
		$smarty = $_SESSION["smarty"];
	} else {
		$smarty = new smartyML(DEFAULT_LANGUAGE);
		$smarty->template_dir = TEMPLATES_PATH;
		$smarty->compile_dir = TEMPLATES_C_PATH;
}
		$smarty->assign("TabHref", array("index.php?main_tabid=0&amp;main_content=index_export.php",
										 "index.php?main_tabid=1&amp;main_content=index_files_backup.php",
										 "index.php?main_tabid=2&amp;main_content=index_settings.php",
										 "index.php?main_tabid=3&amp;main_content=index_test_backup.php",
										 "index.php?Logout=yes"));

		$smarty->assign("TabCaption", array($GLOBALS['databaseBackup'], $GLOBALS['webFilesBackup'], $GLOBALS['systemSettings'], $GLOBALS['testBackup'],$GLOBALS['logOut']));

		if (isset($main_tabid)) {
			$smarty->assign("TabId", $main_tabid);
		} else {
			$smarty->assign("TabId", "");
		}

		//$smarty->assign("ContentBuffer", $content_buf);

$body = '';
if ($is_mysql_result) {
	$db_backup_pro->freeresult($result);
	//ob_end_clean();
	$smarty->assign("db_select", $db_select);
	$body = '<table cellspacing="2" cellpadding="3" align="left"><tr><td><b>Backup Process Started......</b></td></tr>';

	for($i = 0 ; $i < count($db_select) ; $i++)
	{
		$body.= '<tr><td>Requesting Backup for....TableName: <b>'.$db_select[$i]."</b></td></tr>";
	}
	 $body.= "<tr><td><br><b>Backup Process Completed Successfully.</b></td></tr></table>";
}

if($Success == 'true')
{
	$smarty->assign("current_db_new", $current_db_new);
	$smarty->assign("table_new", $table_new);
	if($compression == 'none')
	{
		$str = $writer->filename;
	 }
	 else
		 $str = $writer->filename;
	$str = str_replace("..",".",$str);

	if ($backup_method == 'local_backup') {
		$smarty->assign("download_link_db", $download_link_db);
	}
	if ($backup_method == 'ftp_backup' && $errorOccurs == false) {
		$smarty->assign("backup_method", $backup_method);
		$smarty->assign("errorOccurs", $errorOccurs);
		$smarty->assign("ftp_host", $ftp_host[$i]);
	} elseif ($backup_method == 'ftp_backup' && $errorOccurs == true) {
		$smarty->assign("backup_method", $backup_method);
		$smarty->assign("errorOccurs", $errorOccurs);
	}
	if($backup_method == 'email_backup') {
		$smarty->assign("str", $str);
		$sent_mail = $mail_to;
		if ($mail_cc != "") {
			$sent_mail .= ", ".$mail_cc;
		}
		$smarty->assign("mail_to", $sent_mail);
		$smarty->assign("backup_method", $backup_method);
	}
	$body.= '</table>';
}
$_SESSION['mailbody'] = $body;
#echo $body;
//ob_end_clean();
if (isset($_SESSION["mail_err"])) {
	$smarty->assign("mail_err", 1);
}
$smarty->assign("done", "1");
$smarty->display('db_sucess.tpl');
?>